// C Source File
// Created 24/08/2002; 21:56:59

#include <tigcclib.h>         // Include All Header Files
#include "sprite.h"
#include "special.h"
#include "sprite_gris.h"


// Dclaration des variables globales
extern GRDEUR ecran;
extern short rg_esc, col_esc, col_haut, col_droite, col_gauche, col_2nd;	
extern CARACT ennemi[29];
extern EXPLO explo[max_explo];
extern char ralenti;

inline void dessinvsso (POS posi, float d) {
	short dir = droite; // prend les valeus d l'numration "direction"
	
	// on utilise le paramtre d comme un variable locale de toute faon c'est un paramtre par dfaut donc n'affecte pas la valeur du programme principal
	// on ajuste d pour qu'il soit compris entre 0 et 2*PI et on le fait  chaque que l joueur change de diretion

	// on cherche le sprite quivalent  la diirection du vsso, la valeur par dfaut est droite
	if (d >= PI/4) dir = haut;
	if (d >= 3*PI/4) dir = gauche;
	if (d >= 5*PI/4) dir = bas;
	if (d >= 7*PI/4) dir = droite;

	// position du vsso correspond  son centre et le sprite est dessin par rapport  son coin suprieur gauche
	Sprite8 (posi.x - trunc(taille_vsso/2), posi.y - trunc(taille_vsso/2), 
					taille_vsso, dessin_vsso[dir], LCD_MEM, SPRT_XOR);

}  


void dessinennemi (POS posi, TYPE type) {
	// la position corespond au centre du sprite, il faut faire un rglage
	if (type.forme == m) {
		Sprite8 (posi.x - trunc(taille_missile/2), posi.y - trunc(taille_missile/2),
						 taille_missile, dessin_missile, LCD_MEM, SPRT_XOR);
		return ;
	}
	if (type.forme == s) {
		Sprite8 (posi.x - trunc(taille_soucoupe/2), posi.y - trunc(taille_soucoupe/2),
						 taille_soucoupe, dessin_soucoupe, LCD_MEM, SPRT_XOR);
		return ;		
	}
	switch (type.taille) {
		case petit:
			Sprite8 (posi.x - 4, posi.y - 4, 8, dessin_ennemip[type.forme], LCD_MEM, SPRT_XOR);
		break;
		case moyen:
			Sprite16 (posi.x - 6, posi.y - 6, 12, dessin_ennemim[type.forme], LCD_MEM, SPRT_XOR);
		break;
		case gros:
			Sprite16 (posi.x - 8, posi.y - 8, 16, dessin_ennemig[type.forme], LCD_MEM, SPRT_XOR);
		break;
	}
	
}


inline void efface (POS posi, float d) {
	dessinvsso (posi,d);
}


inline void affiche (POS posi, float d) {
	dessinvsso (posi,d);
}


inline void dessineexplo (POS posi) {
	Sprite8 (posi.x - 4, posi.y - 4, 8, dessin_explo, LCD_MEM, SPRT_XOR);
}


// nveu paramtre car on considre que tous les spites seront des carrs car ils sont symtriques et puis c'est plus pratique
void transfert (POS *posi, unsigned char taille) { 
	if (posi->x + taille/2 >= ecran.largeur) 
		posi->x = taille - ecran.largeur + posi->x;
	if (posi->x - taille/2 <= 0)
		posi->x = ecran.largeur - taille + posi->x;
	if (posi->y + taille/2 >= ecran.hteur)
		posi->y = taille + posi->y - ecran.hteur;
	if (posi->y - taille/2 <= 0)
		posi->y = ecran.hteur - taille + posi->y;
}


void deplavsso (POS *nvelle_pos, float dir) {
	efface(*nvelle_pos, dir);
	nvelle_pos->y -= vit * sin(dir);	// pour que l'origine des radians soit comme en maths et il faut penser  le faire pour tout les sin du prog car l'origine est en haut  gauche au lieu d'en bas  gauche comme on a l'habitude en maths, en plus l'axe des ordonnes est dirigs vers le bas
	nvelle_pos->x += vit * cos(dir);
	transfert(nvelle_pos, taille_vsso); // pas d'toile r c'est un pointeur et on veut son addresse
	affiche(*nvelle_pos, dir);
}


void deplacanon (POS posi, float *d, float sens) {
	efface(posi,*d);
	*d = *d + sens;
	if (*d > 2 * PI) *d -= 2 * PI;
	if (*d < 0) *d += 2 * PI;
	affiche(posi,*d);
}


short deplaennemi (POS *posi, float *d, TYPE carac, POS vsso) {
	POS ancienne;	
	
	
	dessinennemi (*posi, carac);
	switch (carac.forme) {
		case t2:
		case t4:
		/*
		Je t'avoue j'ai eu beaucoup de mal  trouver cette procdure. J'ai fait pas mal  taton
		J'ai utilis 2 variable de sorti pour voir ce qui se passait mais cela ne m'a pas trop aid ici mais dans 
		d'autres situaations c'est trs utile voil pourquoi je l'ai laiss ici
		tu utilise aussi un seul ennemi pour que a soit plus clair et puisse mieux analys la situation
		*/
			if (vsso.x - posi->x != 0) {
				if (vsso.x < posi->x) {
					*d = atan ( -(vsso.y - posi->y) / (vsso.x - posi->x) );  // ne pas oubli que vsso est un pointeur comme jai fait au dbut avant la correction etl'erreur est assez dur  voir
					*d += PI;
				} else {
					*d = atan ( (vsso.y - posi->y) / (-vsso.x + posi->x) );
				}
			}
		/*
		Voici l'explication plus ou moins marhmatiques
		pour cela tu trace un cercle trigonomtrique et tu trace la droite verticale  droite reprsentant
		la tangente
		tu te rend compte que PI/4 et PI/4 + PI = 5PI/4 ont la mme tangente
		c'est pour cela qu'il faut faire 2 cas et ceci ne m'est pas venu  l'ide imdiatement
		l'histoire des moins vient toujours du fait que l'orienation des axes de la Ti est diffrente de ce que
		l'on a l'habitude de vooir en maths
		j'espre que c'est maintenant plus clair sinon essaye de modifier les moins ou les cas et tu verras par
		toi	mme ce qui se passe	
		
		remarque: tu peux croire qu'il y a un bug quand tu es prs du bord car l'ennemi es trop gros pour
		pouvor passer et il saute de l'autre cot et traverse l'cran pour te rejoindre mais normalement
		tu serais dj mort mais la mort du joueur c'est pour plus tard
		la tour Eiffel ne s'est pas construite en un jour
		*/
		case t1:
		case t3:
		case s: // la sououpe ragit comme les autres ennemis
			posi->x += (3 - carac.taille) * (carac.taille + vitm) * cos(*d); // on rajoute a pour acclrer un chouia seulement les gros et moyens pour que la direction soit plus raliste et que pour les faibles angles on est un changeemnt de dirction visible
			posi->y -= (3 - carac.taille) * (carac.taille + vitm) * sin(*d);
			transfert (posi, 8 + 4 * carac.taille); // pas * pr posi car pointeur et ici on veut l'addresse
			dessinennemi (*posi, carac);
		break;
		case m: //la particularit du missile qd il touche le bord il meurt
			posi->x += (3 - carac.taille) * vitm * cos(*d); 
			posi->y -= (3 - carac.taille) * vitm * sin(*d);
			ancienne = *posi;
			transfert (posi, 8 + 4 * carac.taille); // pas * pr posi car pointeur et ici on veut l'addresse
			if ((ancienne.x != posi->x) || (ancienne.y != posi->y)) {
				return (2); // mort du missile il ne peut pas traverser l'cran
			} else {
				dessinennemi (*posi, carac);
			}
		break;
	}	
	return (1);
}


void chargeniv (char a1, char a2, char a3, char a4, POS *joueur, float *d,
								short n, unsigned long int pt, short v) {
	
	ClrScr();
	tracecadre();
	affichage (n, pt, v);
	
	// ennemis
	init_posi();
	init_forme(a1, a2, a3, a4); 
	init_taille();
	init_explo();

	joueur->x = trunc(ecran.largeur/2);
	joueur->y = trunc(ecran.hteur/2);
	*d = PI / 2;

	depla_pondeuse ();	
	affiche (*joueur, *d);
}


inline void init_explo() {
	short a;
	for (a = 0; a < max_explo; a++) explo[a].etat = 0;
}


inline void init_forme(char a1, char a2, char a3, char a4) {
	short a;
	
	for (a = 0; a < 7; a++) {
		ennemi[a].type.forme = a1;
		ennemi[a + 7].type.forme = a2;
		ennemi[a + 14].type.forme = a3;
		ennemi[a + 21].type.forme = a4;
	}
	ennemi[28].type.forme = s;

}


inline void init_posi() {
	short a;
	
	for (a = 0; a < 28; a++) {
		//ennemi[a].type.forme = t1; //  valable seulement pour le niveau 1
		ennemi[a].posi.x = random(ecran.largeur - 1) + 1; // au dbut ce sont des oeufs donc aucun problme: talle d'un pixel
		ennemi[a].posi.y = random(ecran.hteur - 1) + 1;
		ennemi[a].dir = hasard()*2*PI;
		//DrawPix (ennemi[a].posi.x, ennemi[a].posi.y, A_XOR); c'est la pondeuse qui s'en charge
		ennemi[a].etat = 0;
	}
	a = random(4);
	ennemi[28].etat = 0;

	// position bas par dfaut
	ennemi[28].posi.x = trunc( ecran.largeur / 2);
	ennemi[28].posi.y = ecran.hteur - 13;
	ennemi[28].dir = PI / 2;
	if (a == haut) {
		ennemi[28].posi.x = trunc( ecran.largeur / 2);
		ennemi[28].posi.y = 13;
		ennemi[28].dir = 3 * PI / 2;	
	}
	if (a == gauche) {
		ennemi[28].posi.x = 13;
		ennemi[28].posi.y = trunc( ecran.hteur / 2);
		ennemi[28].dir = 0;
	}
	if (a == droite) {
		ennemi[28].posi.x = ecran.largeur - 13;
		ennemi[28].posi.y = trunc( ecran.hteur / 2);
		ennemi[28].dir = PI;
	}

	
}


inline void init_taille() {
	short a;
	
	for (a = 0; a < 28; a += 7) {
		short z;

		/*
								0: gros
								1, 2: moyen
								3, 4, 5, 6: petit
								
								7: gros
								8, 9: moyen
								10, 11, 12, 13: petit
								
								14: gros
								15, 16: moyen
								17, 18, 19, 20: petit
								
								21: gros
								22, 23: moyen
								24, 25, 26, 27: petit		
		*/
		ennemi[a].type.taille = gros;
		//ennemi[a].etat = 1; la naissance des ennemis se fait chacun  leur tour et un moment aprs le 
		// dpart c'est pour pas qu'un ennemi apparaisse sur le vaisseau

		// on rgle la position au centre du sprite donc lors de l'closion on est bon
		ennemi[a + 1].type.taille = moyen;
		ennemi[a + 2].type.taille = moyen;

		for (z = a + 3; z < a + 7; z++) ennemi[z].type.taille = petit; 
	}	
	ennemi[28].type.taille = petit;
}


inline short collision (POS posi1, POS posi2, unsigned char inter) { // retourne un boolen en fait
	if ((posi2.x < posi1.x + inter) && (posi2.x > posi1.x - inter)
			&& (posi2.y < posi1.y + inter) && (posi2.y > posi1.y - inter))
						return 1;
	return 0;
}


inline short arret() {
	if (_rowread(rg_esc) & col_esc) return 1; // 0=FALSE et 1=TRUE
	return 0;
}


inline void tracecadre() {
	DrawLine(0,0,0,ecran.hteur,A_NORMAL);
	DrawLine(0,ecran.hteur,ecran.largeur,ecran.hteur,A_NORMAL);
	DrawLine(ecran.largeur,ecran.hteur,ecran.largeur,0,A_NORMAL);
	DrawLine(ecran.largeur,0,0,0,A_NORMAL);	
}


inline float hasard() {
	// renvoie un nombre au hasard entre -1 et 1
	return ( cos( rand() ) );
} 


void naissance (CARACT *ennemi) {
		ennemi->etat = 1;
		DrawPix (ennemi->posi.x, ennemi->posi.y, A_XOR); // on efface l'oeuf
		//naissance	
		transfert (&(ennemi->posi), 8 + 4 * ennemi->type.taille); 
		// on prend l'adresse du pointeur drfrencer, c'esi chaud loup
		dessinennemi (ennemi->posi, ennemi->type);		
}


void init_oeuf_s (CARACT *eni, char t) {
		eni->etat = 0;
		eni->posi = ennemi[28].posi;
		eni->type.forme = t;
		eni->type.taille = random (3);
		DrawPix (eni->posi.x, eni->posi.y, A_XOR);
}


void teleport (POS *posi, float *d) {
	efface (*posi, *d);
	*d = PI/2;
	posi->x = random(ecran.largeur - 1) + 1; 
	posi->y = random(ecran.hteur - 1) + 1;
	transfert(posi, taille_vsso); // pas d'toile 'posi' est un pointeur et on veut son addresse
	affiche (*posi, *d);
}


inline void dessine_balle (POS posi) {
	Sprite8 (posi.x, posi.y, 2, dessin_balle, LCD_MEM, SPRT_XOR);
}

inline void dessine_pondeuse (POS posi) {
	Sprite32 (posi.x, posi.y, 16, dessin_pondeuse, LCD_MEM, SPRT_XOR);
}

inline void depla_pondeuse () {
	short a, z, aux1, aux2;
	POS oeuf[28];
	POS pondeuse ={trunc (ecran.largeur / 2 - 16), ecran.hteur - 16};
	
	for (a = 0; a < 28; a++) {
		oeuf[a].x = ennemi[a].posi.x;
		oeuf[a].y = ennemi[a].posi.y;
	}
	
	for (a = 0; a < 27; a++) {
		for (z = a + 1; z < 28; z++) {
			if (oeuf[a].y < oeuf[z].y) {
				 aux1 = oeuf[a].y;
				 oeuf[a].y = oeuf[z].y;
				 oeuf[z].y = aux1;
				 aux2 = oeuf[a].x;
				 oeuf[a].x = oeuf[z].x;
				 oeuf[z].x = aux2;	
			}
		}
	}

	z = 0;
	for (pondeuse.y = ecran.hteur - 16; pondeuse.y > -17; pondeuse.y -= vit_pondeuse) {
		dessine_pondeuse (pondeuse);
		for (a = z; a < 28; a++) {
			if (oeuf[a].y > pondeuse.y + 16) {
				DrawPix (oeuf[a].x, oeuf[a].y, A_XOR);
				z = a + 1;
			}
		}
		attente (2);
		dessine_pondeuse (pondeuse); // efface la pondeuse
	}

}

void attente (short att) {
	short a;
	
	for (a = 0; a < att; a++) 
		hasard ();
}

void affichage (short n, unsigned long int pt, short v) { // niveau, points, nb de vies
	char aux[11]; // "niveau: 255" est une des plus grosses chanes et contient 11 caractres 
	short a = 0;

	FontSetSys (F_4x6);
	
	DrawStr (1, ecran.hteur +3, "Points:", A_XOR);
	affichage_pt (pt);
	
	sprintf (aux, "Level: %hi", n);
	DrawStr (1, ecran.hteur + 3 +7, aux, A_XOR);
	
	
	while ((a < v) && (a < 14)) {
		Sprite8 (ecran.largeur + 3, 1 + a * (taille_vsso + 2), 
						taille_vsso, dessin_vsso[haut], LCD_MEM, SPRT_XOR);
		a++;
	}
	if (v >= 15) {
		sprintf (aux, "%hi x", v - 13);
		DrawStr (ecran.largeur - 13, ecran.hteur + 9, aux, A_XOR);
	}
	
}

void affichage_pt (unsigned long int pt) { // attention ne pas dpasser les 4 Md
	char aux[73];
	
	sprintf (aux, "%lu", pt);
	DrawStr (28, ecran.hteur +3, aux, A_XOR);
}

void victoire (POS posi, float d, short n, unsigned long int pt, short v) {
	char bon = 0; // variable boulennes
	TYPE croix = {petit, m};
	short a, z;
	float pas;
	float d1, d2, d3;
	char aux[11];

	
	do {
		
		for (a = 0; a < max_explo; a++) {
			if (explo[a].etat == 1) 
				// explosion termin
				dessineexplo (explo[a].posi);
			if (explo[a].etat != 0) explo[a].etat--;
		}
		
		attente (3);
		efface (posi, d);
		// on se dmerde pour que l'angle soit compris entre 0 et 2Pi
		while (d > 2 * PI) {
			d -= 2 * PI;
		} 
		while (d < 0) {
			d += 2 * PI;
		} 
	
		if ((d > PI / 4) && (d < 3 * PI / 4)) {
			bon = 1; // le dplacement du canon est termin	
		} else {
			if ((d > PI / 2) && (d < 3 * PI / 2)){
				d -= vit_canon;
			} else {
				d += vit_canon;
			}
		}
		
		if (posi.x < trunc(ecran.largeur / 2)) posi.x++;
		if (posi.x > trunc(ecran.largeur / 2)) posi.x--;
		if (posi.y < trunc(ecran.hteur / 2)) posi.y++;
		if (posi.y > trunc(ecran.hteur / 2)) posi.y--;
		affiche (posi, d);
		
	} while ( (!bon) || (posi.x != trunc(ecran.largeur / 2)) || (posi.y != trunc(ecran.hteur / 2)) );
	
	// on efface toutes les explosions non effaces
	for (a = 0; a < max_explo; a++) 
		if (explo[a].etat != 0) dessineexplo (explo[a].posi);
	
	// toiles de la victoire

	d1 = d2 = d3 = 0;
	
	pas = 2 * PI / nb1;
	for (a =0; a < nb1; a++) {
		posi.x = trunc (trunc(ecran.largeur / 2) + r1 * cos (a * pas + d1));
		posi.y = trunc (trunc(ecran.hteur / 2) - r1 * sin (a * pas + d1));		
		dessinennemi (posi, croix);
	}
	pas = 2 * PI / nb2;
	for (a =0; a < nb2; a++) {
		posi.x = trunc (trunc(ecran.largeur / 2) + r2 * cos (a * pas + d2));
		posi.y = trunc (trunc(ecran.hteur / 2) - r2 * sin (a * pas + d2));		
		dessine_balle (posi);
	}
	pas = 2 * PI / nb3;
	for (a =0; a < nb3; a++) {
		posi.x = trunc (trunc(ecran.largeur / 2) + r3 * cos (a * pas + d3));
		posi.y = trunc (trunc(ecran.hteur / 2) - r3 * sin (a * pas + d3));		
		dessinennemi (posi, croix);
	}		
	
	for (z = 0; z < nb_tour; z++) {	
/*
Je trouve l'effet plus jolie avec seulement le dplacement de du dernier cercle
le garde au cas o je change d'avis

		d1 += v1;
		pas = 2 * PI / nb1;
		for (a =0; a < nb1; a++) {
			posi.x = trunc (trunc(ecran.largeur / 2) + r1 * cos (a * pas + d1 - v1));
			posi.y = trunc (trunc(ecran.hteur / 2) - r1 * sin (a * pas + d1 - v1));		
			dessinennemi (posi, croix);
			posi.x = trunc (trunc(ecran.largeur / 2) + r1 * cos (a * pas + d1));
			posi.y = trunc (trunc(ecran.hteur / 2) - r1 * sin (a * pas + d1));		
			dessinennemi (posi, croix);			
		}
		d2 += v2;
		pas = 2 * PI / nb2;
		for (a =0; a < nb2; a++) {
			posi.x = trunc (trunc(ecran.largeur / 2) + r2 * cos (a * pas + d2 - v2));
			posi.y = trunc (trunc(ecran.hteur / 2) - r2 * sin (a * pas + d2 - v2));		
			dessine_balle (posi);
			posi.x = trunc (trunc(ecran.largeur / 2) + r2 * cos (a * pas + d2));
			posi.y = trunc (trunc(ecran.hteur / 2) - r2 * sin (a * pas + d2));		
			dessine_balle (posi);
		}
*/
		d3 += v3;
		pas = 2 * PI / nb3;
		for (a =0; a < nb3; a++) {
			posi.x = trunc (trunc(ecran.largeur / 2) + r3 * cos (a * pas + d3 - v3));
			posi.y = trunc (trunc(ecran.hteur / 2) - r3 * sin (a * pas + d3 - v3));		
			dessinennemi (posi, croix);
			posi.x = trunc (trunc(ecran.largeur / 2) + r3 * cos (a * pas + d3));
			posi.y = trunc (trunc(ecran.hteur / 2) - r3 * sin (a * pas + d3));		
			dessinennemi (posi, croix);
			if (arret()) break;		
		}	
		if (arret()) break;		
	}
	ClrScr();
	FontSetSys (F_8x10);
	sprintf (aux, "Level: %hi", n);
	DrawStr (trunc (ecran.largeur / 2) - 31, trunc (ecran.hteur / 2) - 2, aux, A_XOR);
	tracecadre();
	affichage (n, pt, v);	
	attente (93);
}

void perdu (short v, POS posi, float d, unsigned long int pt) {
	short a, tps = 0;
	char deja = 0;
	char aux[73];
	
	efface (posi, d);	
	Sprite16 (posi.x - 8, posi.y - 8, 16, dessin_explo_vsso, LCD_MEM, SPRT_XOR);
		
	while (!arret()) {
		attente (5);
		for (a = 0; a < max_explo; a++) {
			if (explo[a].etat == 1) 
				// explosion termin
				dessineexplo (explo[a].posi);
			if (explo[a].etat != 0) explo[a].etat--;
		}
				
		for (a = 0; a < 29; a++) 
			if (ennemi[a].etat == 1) 
			  ennemi[a].etat = deplaennemi2 (&ennemi[a].posi, &ennemi[a].dir, ennemi[a].type);	

		if ((v != 0) && (arret())) break;

		tps++;
		FontSetSys (F_8x10);
		if ((tps > tps_prem_eclosion / 13) && (!deja)) {
			deja = 1;
			if (v != 0) {
				DrawStr (trunc (ecran.largeur / 2) - 17, trunc (ecran.hteur / 2) - 2, "Lost", A_XOR);	
			} else {
				DrawStr (trunc (ecran.largeur / 2) - 31, trunc (ecran.hteur / 2) - 2, "Game over", A_XOR);
				sprintf (aux, "%lu", pt);
				DrawStr (trunc (ecran.largeur / 2) - 31, trunc (ecran.hteur / 2) + 17, aux, A_XOR);
			}
			Sprite16 (posi.x - 8, posi.y - 8, 16, dessin_explo_vsso, LCD_MEM, SPRT_XOR);
		}
		if ((tps >= tps_prem_eclosion) && (ennemi[0].etat == 0)) {
				ennemi[0].etat = 1;
				DrawPix (ennemi[0].posi.x, ennemi[0].posi.y, A_XOR);
				transfert (&ennemi[0].posi, 16);
				dessinennemi (ennemi[0].posi, ennemi[0].type);
		} 
		if ((tps >= tps_prem_eclosion +  tps_eclosion) && (ennemi[7].etat == 0)) {
				ennemi[7].etat = 1;
				DrawPix (ennemi[7].posi.x, ennemi[7].posi.y, A_XOR);// on oublie pas d'effacer l'oeuf clos
				transfert (&ennemi[7].posi, 16);
				dessinennemi (ennemi[7].posi, ennemi[7].type);
		}
		if ((tps >= tps_prem_eclosion + 2 * tps_eclosion) && (ennemi[14].etat == 0)) {
				ennemi[14].etat = 1;
				DrawPix (ennemi[14].posi.x, ennemi[14].posi.y, A_XOR);
				transfert (&ennemi[14].posi, 16);
				dessinennemi (ennemi[14].posi, ennemi[14].type);		
		}
		if ((tps >= tps_prem_eclosion + 3 * tps_eclosion) && (ennemi[21].etat == 0)) {
				ennemi[21].etat = 1;
				DrawPix (ennemi[21].posi.x, ennemi[21].posi.y, A_XOR);
				transfert (&ennemi[21].posi, 16);
				dessinennemi (ennemi[21].posi, ennemi[21].type);
		}	
		if (tps > tps_prem_eclosion + 3 * tps_eclosion) tps = 0; // le dernier  apparatre doit tre apparu sinon problme
	}

}

short deplaennemi2 (POS *posi, float *d, TYPE carac) {
	POS ancienne;	
	
	
	dessinennemi (*posi, carac);
	switch (carac.forme) {
		case t2:
		case t4:
		case t1:
		case t3:
		case s: // la sououpe ragit comme les autres ennemis
			posi->x += (3 - carac.taille) * vitm * cos(*d);
			posi->y -= (3 - carac.taille) * vitm * sin(*d);
			transfert (posi, 8 + 4 * carac.taille); // pas * pr posi car pointeur et ici on veut l'addresse
			dessinennemi (*posi, carac);
		break;
		case m: //la particularit du missile qd il touche le bord il meurt
			posi->x += (3 - carac.taille) * vitm * cos(*d);
			posi->y -= (3 - carac.taille) * vitm * sin(*d);
			ancienne = *posi;
			transfert (posi, 8 + 4 * carac.taille); // pas * pr posi car pointeur et ici on veut l'addresse
			if ((ancienne.x != posi->x) || (ancienne.y != posi->y)) {
				return (2); // mort du missile il ne peut pas traverser l'cran
			} else {
				dessinennemi (*posi, carac);
			}
		break;
	}	
	return (1);
}

char presentation () {
	
	ClrScr();
	FontSetSys (F_8x10);
	DrawStr (trunc (ecran.largeur / 5), trunc (ecran.hteur / 4) + 7, "Quiche", A_XOR);
	DrawStr (trunc (ecran.largeur / 4), trunc (ecran.hteur / 2) + 7, "Production", A_XOR);
	FontSetSys (F_6x8);
	DrawStr (trunc (ecran.largeur / 13), ecran.hteur, "www.quiche-team.fr.tc", A_XOR);
	
	attente (117);
	
	ClrScr();
	image();		
	
	return (menu ());
}

void image() {
    unsigned char* plan1;
    unsigned char* plan2;
    unsigned char* dest1;
    unsigned char* dest2;
    unsigned char* src1;
    unsigned char* src2;
    int            a;
    
    //-----------------------------------------------
    // turn on grayscale graphics subsystem
    //-----------------------------------------------
    if (!GrayMode(GRAY_ON)) {
        return;
    }
    //-----------------------------------------------
    // fetch start addresses of planes
    //-----------------------------------------------
    plan1 = GetPlane(0);
    plan2 = GetPlane(1);

    //-----------------------------------------------
    // due to the fact that the LCD size of the TI89
    // is internally the same than the LCD size of 
    // the TI92 we cannot directly copy the complete
    // contents of the layer1 and layer2 arrays into
    // the bitplanes, but we have to copy each line
    // separately taking the offsets at each line
    // into account
    //-----------------------------------------------

    dest1 = plan1;
    dest2 = plan2;
    src1  = layer1;
    src2  = layer2;

    //-----------------------------------------------
    // on the TI92 we have to clear both bitplanes
    // because the skipped parts will be visible
    //
    // additionally we have to add an initial offset
    // to the destination pointers
    //-----------------------------------------------
    if (!TI89) {
        memset(plan1,0,LCD_SIZE);
        memset(plan2,0,LCD_SIZE);

        //-------------------------------------------
        // setup the destination pointers taking the 
        // initial offset into account
        // (each line consists of 30 bytes on a TI92)
        //-------------------------------------------
        dest1 += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2 += ((128-100)*30)/2 + ((240-160)/8)/2;
    }

    //-----------------------------------------------
    // ... and now copy all lines from the data 
    // arrays to the bitplanes
    //-----------------------------------------------
    for (a = 0; a < 100; a++, src1 += 20, src2 += 20, dest1 += 30, dest2 += 30) {
        memcpy(dest1,src1,20);
        memcpy(dest2,src2,20);
    }
    
                
    //-----------------------------------------------
    // wait that the user presses a key ...
    //-----------------------------------------------
		ngetchx();
    //-----------------------------------------------
    // cleanup and bye =8-)
    //-----------------------------------------------
    GrayMode(GRAY_OFF);
}

char menu () {
	short clef;
	
	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (13, 7, "F1 - game", A_XOR);
	DrawStr (13, 7 + 17, "F2 - option", A_XOR);
	DrawStr (13, 7 + 17 * 2, "F3 - help", A_XOR);
	DrawStr (13, 7 + 17 * 3, "F4 - exit", A_XOR);

	clef = ngetchx();
	
	switch (clef) {
		case KEY_F1:
		case KEY_ENTER:
			return (0);
			
		case KEY_F2:
			menuoption();
			break;
			
		case KEY_F3:
			menuaide();
			break;
			
		case KEY_F4:
		case KEY_ESC:
			return (1);		
	}
	return (menu());		
}

void menuaide() {
	short clef;
	
	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (13, 7, "F1 - help", A_XOR);
	DrawStr (13, 7 + 17, "F2 - how can i make", A_XOR);
	DrawStr (13, 7 + 17 + 13, "     this game ?", A_XOR);
	DrawStr (13, 7 + 17 * 2 + 13, "F3 - about ...", A_XOR);
	DrawStr (13, 7 + 17 * 3 + 13, "F4 - return", A_XOR);

	clef = ngetchx();
	
	switch (clef) {
		case KEY_F1:
			aide();
			break;
			
		case KEY_F2:
			tutorial();
			break;
			
		case KEY_F3:
			propos();
			break;
			
		case KEY_F4:
		case KEY_ESC:
			return;		
	}
	menuaide();		
}

void menuoption() {
	short clef;
	char diff[3][14] = {"       easy", "       middle", "       hard"};
	short choix = 0;
	
	switch (ralenti) {
		case easy:
			choix = 0;
			break;
		case middle:
			choix = 1;
			break;
		case hard:
			choix = 2;
			break;						
	}

	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (13, 7, "F1 - difficulty:", A_XOR);
	DrawStr (13, 7 + 13, diff[choix], A_XOR);
	DrawStr (13, 7 + 13 + 17, "F2 - return", A_XOR);

	clef = ngetchx();
	
	switch (clef) {
		case KEY_F1:
			switch (ralenti) {
				case hard:
					ralenti = easy;
					break;
				case middle:
					ralenti = hard;
					break;
				case easy:
					ralenti = middle;
					break;
			}			
			break;
			
		case KEY_F2:
		case KEY_ESC:		
			return;	
			break;	
	}
	menuoption();		
}




void propos() {
	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (1, 1 + 8*0, "     Frdric RIVAL", A_XOR);
	DrawStr (1, 1 + 8*1 + 7, " Member of Quiche Team", A_XOR);	
	
	//DrawStr (1, 1 + 8*5, "     Graticiel", A_XOR);	
	DrawStr (1, 1 + 8*5, "version: 1.0  (04-17-02)", A_XOR);
	DrawStr (1, 1 + 8*7, "Code source", A_XOR);
	DrawStr (1, 1 + 8*8, "  available on:", A_XOR);
	DrawStr (1, 1 + 8*9 + 7, " www.quiche-team.fr.tc", A_XOR);
	
	ngetchx();
}

void aide () {
	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (1, 1 + 10*0, "    Keys:", A_XOR);	
	DrawStr (1, 1 + 10*2, "up:    move", A_XOR);	
	DrawStr (1, 1 + 10*3, "left:  move the gun", A_XOR);	
	DrawStr (1, 1 + 10*4, "       to left", A_XOR);	
	DrawStr (1, 1 + 10*5, "right: move the gun", A_XOR);	
	DrawStr (1, 1 + 10*6, "       to right", A_XOR);		
	DrawStr (1, 1 + 10*7, "2nd:   tlportation", A_XOR);	
	DrawStr (1, 1 + 10*8, "Esc:   quitter", A_XOR);	

	ngetchx();
	
	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (1, 1 + 10*0, "    Ennemis:", A_XOR);	
	DrawStr (1, 1 + 10*2, "T1: simple asterod", A_XOR);	
	DrawStr (1, 1 + 10*3, "T2: asterod follows you", A_XOR);	
	DrawStr (1, 1 + 10*4, "T3: T1 + bomb", A_XOR);	
	DrawStr (1, 1 + 10*5, "    when it explods", A_XOR);	
	DrawStr (1, 1 + 10*6, "T4: T2 + T3", A_XOR);		
	DrawStr (1, 1 + 10*7, "Saucer: lays eggs and", A_XOR);	
	DrawStr (1, 1 + 10*8, "        moves randomly", A_XOR);	

	ngetchx();
}

void tutorial() {
	ClrScr();
	FontSetSys (F_6x8);
	DrawStr (1, 1 + 8*0, "      Tutorial", A_XOR);	
	DrawStr (1, 1 + 8*2, "available in french", A_XOR);	
	DrawStr (1, 1 + 8*3, "and in english on:", A_XOR);	
	DrawStr (1, 1 + 8*5, " www.quiche-team.fr.tc", A_XOR);	
	DrawStr (1, 1 + 8*8, "created by:", A_XOR);	
	DrawStr (1, 1 + 8*9 + 5, "     the Quiche Team", A_XOR);	

	ngetchx();
}

void gestion_tueur(short a, POS vsso) {
	short z;
	
	 dessinennemi (ennemi[a].posi, ennemi[a].type); 
	// dessine  l'explosion de l'ennemi
	char bon = 0;
	for (z = 0; z < max_explo ; z++) {
		if (explo[z].etat == 0) {
			explo[z].posi = ennemi[a].posi;
			explo[z].etat = tps_explo;
			bon = 1;
			dessineexplo (explo[z].posi);
			break;
		}
	}
	if (!bon) {
		unsigned char h = random(max_explo); // on prend un nombre au hasard pour viter une boucle pour calculer le plus petit temps d'explosion
		dessineexplo (explo[h].posi); 
		explo[h].posi = ennemi[a].posi;
		explo[h].etat = tps_explo;					
		dessineexplo (explo[h].posi);			
	}		

	if (ennemi[a].type.taille == gros) {
		if (ennemi[a+1].etat == 0) naissance( &ennemi[a+1] );
		if (ennemi[a+2].etat == 0) naissance( &ennemi[a+2] );
	}
	if (ennemi[a].type.taille == moyen) {
		if (ennemi[ a + (a % 7) + 1 ].etat == 0) naissance ( &ennemi[ a + (a % 7) + 1 ] );
		if (ennemi[ a + (a % 7) + 2 ].etat == 0) naissance ( &ennemi[ a + (a % 7) + 2 ] );
	}
	if ((ennemi[a].type.forme == t3) || (ennemi[a].type.forme == t4)) {
		// une sorte de transformation avant de mourir
		//ennemi[a] tjrs vivant ms forme m: missile
		ennemi[a].type.forme = m;
		ennemi[a].type.taille = petit; // pour que le issile va aussi vite que les petits
			
		// pas besoin de se casser les couilles  chercher on copie la partie de deplaennemi
		if (vsso.x - ennemi[a].posi.x != 0) {
			if (vsso.x < ennemi[a].posi.x) {
				ennemi[a].dir = atan ( -(vsso.y - ennemi[a].posi.y) / (vsso.x - ennemi[a].posi.x) );  
				ennemi[a].dir += PI;
			} else {
				ennemi[a].dir = atan ( (vsso.y - ennemi[a].posi.y) / (-vsso.x + ennemi[a].posi.x) );
			}
		}	// normalement si horizontale du missile il y a un bug ms c'est fait exprs et on aura une ttrajectoire alatoire
		// naissance  l'cran de l'ennemi
		dessinennemi (ennemi[a].posi, ennemi[a].type);											
	} else {
		ennemi[a].etat = 2;
	}
}



